#include <SoftwareSerial.h>

#include "SIM800L.h"

#define SIM800_RX_PIN 11
#define SIM800_TX_PIN 10
#define SIM800_RST_PIN 6

SIM800L* sim800l;

void setup() {
  Serial.begin(9600);
  while(!Serial);
  SoftwareSerial* serial = new SoftwareSerial(SIM800_RX_PIN, SIM800_TX_PIN);
  serial->begin(9600);
  delay(1000);
  sim800l = new SIM800L((Stream *)serial, SIM800_RST_PIN, 200, 512);
  Serial.println("Начало теста");

  while(!sim800l->isReady()) {
    Serial.println(F("Проблема инициализации AT команд, повтор через 1 секунду"));
    delay(1000);
  }

  Serial.println("Модуль готов.");

  Serial.print("Модуль ");
  Serial.println(sim800l->getVersion());
  Serial.print("Прошивка ");
  Serial.println(sim800l->getFirmware());

  Serial.print("Номер SIM карты ");
  Serial.println(sim800l->getSimCardNumber());

  uint8_t signal = sim800l->getSignal();
  while(signal <= 0) {
    delay(1000);
    signal = sim800l->getSignal();
  }

  if(signal > 5) {
    Serial.print(F("Сигнал хороший (уровень: "));
  } else {
    Serial.print(F("Сигнал слабый (уровень: "));
  }
  Serial.print(signal);
  Serial.println(F(")"));
  delay(1000);

  NetworkRegistration network = sim800l->getRegistrationStatus();
  while(network != REGISTERED_HOME && network != REGISTERED_ROAMING) {
    delay(1000);
    network = sim800l->getRegistrationStatus();
  }
  Serial.println(F("Регистрация в сети - OK"));
  Serial.println("Конец теста");
}

void loop() {

}
